--Script written by Spawn0
--Copyright (c) 2022 Spawn0


local Cron = require("Cron.lua")
-- Cron
-- https://github.com/psiberx/cp2077-cet-kit


local database1 = require("sp0_items/Database.lua")

local i=1

local vendor_item_list = {}

local itemscreated = 0




registerForEvent("onInit", function()

	--increase vendor items cap to 500
	Override('Vendor', 'GetMaxItemStacksPerVendor;Bool', function() return 500 end)

	
	TweakDB:CloneRecord("Vendors.SP0MustBePresent", "Vendors.CanBePresent")
	TweakDB:SetFlat("Vendors.SP0MustBePresent.max", 1)
	TweakDB:SetFlat("Vendors.SP0MustBePresent.min", 1)

	Cron.NextTick(function()
	
		if database1 ~= nil then
		
			-- create vendor items versions
			for i,a in ipairs(database1) do
				itemname = a.id
				flatName = a.id .. "_vi"
				quality = a.setQuality
				
				--print(flatName)
				TweakDB:CloneRecord(flatName, "Vendors.Clothes_inline0")
				
				vendor_cl_item = tostring(flatName)
				TweakDB:SetFlat(flatName..".item", itemname)
				--print("vendor item created: " .. vendor_cl_item)
				
				if quality == "Quality.Common" then
					TweakDB:SetFlat(flatName..".forceQuality", "Common") 
				end
				
				if quality == "Quality.Rare" then
					TweakDB:SetFlat(flatName..".forceQuality", "Rare") 
				end
				
				if quality == "Quality.Legendary" then
					TweakDB:SetFlat(flatName..".forceQuality", "Legendary") 
				end
				
				if quality == "Quality.Epic" then
					TweakDB:SetFlat(flatName..".forceQuality", "Epic") 
				end
				
				if quality == "Quality.Iconic" then
					TweakDB:SetFlat(flatName..".forceQuality", "Iconic") 
				end
										
				if quality == nil then
					TweakDB:SetFlat(flatName..".forceQuality", "Legendary") 
				end
				 
				TweakDB:SetFlat(flatName..".quantity", {"Vendors.SP0MustBePresent"})
			
			end
			
			
			-- check if item already added to list and if not add it to list
			for index, data in ipairs(database1) do

				--print(index.." item")
				
				itemname2 = data.id
				flatName2 = data.id .. "_vi"		
				vendor_cl_item2 = tostring(flatName2)
				
				if data.store == nil then
					vendor_shop_01 = "Vendors.wat_kab_clothingshop_01"
				else
					vendor_shop_01 = data.store
				end
				
				vendor_item_list = TweakDB:GetFlat(vendor_shop_01..".itemStock")
				
				itemscreated = 0

				for x = 1,600 do
					if vendor_item_list[x] ~= nil then
						--print(tostring(vendor_item_list[x]))
						--print(tostring(TweakDBID.new(data.id)))
						if tostring(vendor_item_list[x]) == tostring(TweakDBID.new(flatName2)) then
							--print("-item already in list")
							itemscreated = 1
						end
					else
						break					
					end

				end		
				
				if itemscreated == 0 then
					table.insert(vendor_item_list, vendor_cl_item2)
					--print("item added to vendor list: " .. vendor_shop_01)
					--itemscreated = 0
				end		
			
			-- set new vendor list
			TweakDB:SetFlat(vendor_shop_01..".itemStock", vendor_item_list)
			
			end
			
		end
	end)
	
	print("SP0 VENDOR ADD ITEMS IS WORKING")
end) 

registerForEvent("onUpdate", function(deltaTime)
	Cron.Update(deltaTime)
end)
